' PAL2YUV
' Converts a JASC-PAL v1.00 to a PC-FX Y8U4V4 palette
' Copyleft 2016 Eponasoft
' This was built in fbc 1.05 but should work fine with any past or future version
'
'        DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE 
'                    Version 2, December 2004 
'
' Copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
'
' Everyone is permitted to copy and distribute verbatim or modified 
' copies of this license document, and changing it is allowed as long 
' as the name is changed. 
'
'            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE 
'   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
'
'  0. You just DO WHAT THE FUCK YOU WANT TO.

' we'll need a few variables
dim as string infile, outfile, inputline, arrayname
dim as integer infh, outfh, red, green, blue, y, u, v, yuv, colorcount, colorloop, breakline
dim as single sy, su, sv, sr, sg, sb

breakline = 3

' check for command string
infile = command$
if infile = "" then
	print "No input file specified"
	end
end if

' trim filename as not to confuse teh open function
infile = trim$(infile)
if left$(infile,1) = chr$(34) then infile = right$(infile,len(infile)-1)
if right$(infile,1) = chr$(34) then infile = left$(infile,len(infile)-1)
' assign the array name and clean out the path and extension
arrayname = infile
if instr(arrayname,"\") > 0 then
	do until instr(arrayname,"\") = 0
		arrayname = right$(arrayname,len(arrayname)-instr(arrayname,"\"))
	loop
end if
if instr(arrayname,".") > 0 then arrayname = left$(arrayname,instr(arrayname,".")-1)

' assign a name for the outfile
outfile = left$(infile,len(infile)-4) & ".yuv"

' get file handles and open teh filez
infh = freefile
open infile for input as #infh
outfh = freefile
open outfile for output as #outfh

' start parsing teh shiznitz
line input #infh, inputline
if trim$(inputline) <> "JASC-PAL" then
	close infh
	close outfh
	print "Only JASC-PAL is supported"
	end
end if
line input #infh, inputline ' this is the palette version... as far as I know, we can skip this for now
line input #infh, inputline ' this will be the color count and is only ever 16 or 256
colorcount = val(inputline)
if colorcount <> 16 and colorcount <> 256 then
	close infh
	close outfh
	print "Only 16 or 256 color palettes are supported"
	end
end if

' looks like we're good to go... write the initial array stuff to the outfile
print #outfh, "const u16 " & arrayname & "_pal[] = { ";

' feed me some color data, bitches
for colorloop = 1 to colorcount
	' read in the line
	line input #infh, inputline
	' parse the color data... don't pretend to understand my technique :P
	red = val(left$(inputline,instr(inputline,chr$(32))))
	inputline = trim$(right$(inputline,len(inputline)-instr(inputline,chr$(32))))
	green = val(left$(inputline,instr(inputline,chr$(32))))
	inputline = trim$(right$(inputline,len(inputline)-instr(inputline,chr$(32))))
	blue = val(inputline)
	print str$(red);" ";str$(green);" ";str$(blue);
	' convert to floats
	sr = red
	sb = blue
	sg = green
	' calculate yuv
	sy = (0.2990 * sr) + (0.5870 * sg) + (0.1140 * sb)
	su = (-0.1686 * sr) - (0.3311 * sg) + (0.4997 * sb) + 128.0
	sv = (0.4998 * sr) - (0.4185 * sg) - (0.0813 * sb) + 128.0
	' clamp values
	if sy > 255.0 then sy = 255.0
	if su > 255.0 then su = 255.0
	if sv > 255.0 then sv = 255.0
	if sy < 0.0 then sy = 0.0
	if su < 0.0 then su = 0.0
	if sv < 0.0 then sv = 0.0
	' convert to integer
	y = sy
	u = su
	v = sv
	' reduce bit depth and get final value
	u = (u + 8) shr 4
	v = (v + 8) shr 4
	yuv = (y shl 8) + (u shl 4) + v
	' output result
	print " -> 0x";hex$(yuv)
	print #outfh,"0x";
	print #outfh,hex$(yuv);
	if colorloop < colorcount then
		print #outfh, ", ";
	end if
	breakline = breakline + 1
	if breakline > 19 then
		breakline = 0
		' this next line inserts a line break into the file... this way, we don't have a single line for 256 color palettes, coz that's really fucking messy
		print #outfh, " "
	end if
next colorloop

print #outfh, " };"

' we be done; close us out
close outfh
close infh

print "PAL2YUV conversion was successful"
end
